![Build](https://github.com/abapGit/abapGit/workflows/main-build/badge.svg)
![Test](https://github.com/abapGit/abapGit/workflows/test-pr/badge.svg)
[![License](https://img.shields.io/github/license/abapGit/abapGit?label=License&color=green)](LICENSE)
[![REUSE Status](https://api.reuse.software/badge/github.com/abapGit/abapGit?color=success)](https://api.reuse.software/info/github.com/abapGit/abapGit)
[![Slack](https://img.shields.io/badge/Join-Slack-blue)](https://communityinviter.com/apps/abapgit/abap)
[![abap package version](https://img.shields.io/endpoint?url=https://shield.abap.space/version-shield-json/github/abapGit/abapGit/src/zif_abapgit_version.intf.abap/c_abap_version&label=version)](https://github.com/abapGit/abapGit/blob/main/src/zif_abapgit_version.intf.abap)


<!--
<picture>
  <source media="(prefers-color-scheme: dark)" srcset="img/logo-dark.svg">
  <source media="(prefers-color-scheme: light)" srcset="img/logo.svg">
  <img height="40" alt="abapGit logo" src="img/logo.svg">
</picture>
--> 

# <a href="https://supportukrainenow.org/"><img src="img/abapGit_in_Ukraine_Colors.svg" height="40" alt="abapGit logo"></a>

<a href="https://supportukrainenow.org/"><img src="img/Ukraine-heart-shape-flag.svg" height="25" alt="Support Ukraine"> Support Ukraine</a>

Git client for ABAP

Works with: [GitHub](https://github.com/),
[GitLab](https://gitlab.com/),
[Assembla](https://www.assembla.com/git/),
[Bitbucket](https://bitbucket.org/),
[abapGitServer](https://github.com/larshp/abapGitServer),
[AWS](https://aws.amazon.com/codecommit/),
[TFS](https://www.visualstudio.com/team-services/git/),
[Azure DevOps](https://azure.microsoft.com/en-us/services/devops) and 
[more](https://git.wiki.kernel.org/index.php/GitHosting).

ABAP Version: 702 or higher

Latest build: [zabapgit_standalone.prog.abap](https://raw.githubusercontent.com/abapGit/build/main/zabapgit_standalone.prog.abap)

*Notes: Some people reported that browsers have issues displaying the file with more than 100k lines. The easiest solution is to "Save as" the link above and then open it with any editor/viewer (notepad included) and copy from there. If your SAP GUI editor freezes when pasting the code, use Utilities > More Utilities > Upload/Download > Upload in the editor instead.*

It is recommended to use SAP GUI for Windows, since there are known issues related to running abapGit and SAP GUI for Java. The focus of abapGit is on supporting [ADT](https://github.com/abapGit/ADT_Frontend) instead of supporting SAP GUI for Java.

## Design Goals

- Easy installation
- Easy upgrade
- Small system footprint
- Code readable in git repository

## Documentation and Guides

https://docs.abapgit.org

## Contributing

You can find the contribution guidelines [here](CONTRIBUTING.md).

## Projects using abapGit

See [dotabap.org](https://dotabap.org) or [this page](https://docs.abapgit.org/other-where-used.html).

## FAQ

For questions/comments/bugs/feature requests/wishes please create an [issue](https://github.com/abapGit/abapGit/issues).

![abapgit](img/abapgit_1_99_0.png)

## Credits and References

- Icons used in abapGit are created from [Font Awesome](https://fontawesome.com/) free icon set ([CC-BY-4.0](LICENSES/CC-BY-4.0.txt))
- [AJSON](https://github.com/sbcgua/ajson) and [String-Map](https://github.com/sbcgua/abap-string-map) are developed by Alexander Tsybulsky ([MIT](LICENSES/MIT.txt))

